%include @Environ(OA32_PATH)\\Code\\Macros\\Model.inc       ;Include & initialize standard modules
SysSetup OOP_PRIMER;, DEBUG(WND)                             ;Loads OOP files and OS related objects

IncludeAPIs ole32, oleaut32                       ;Includes these APIs

% include &MacPath&UStrings.inc                             ;UNICODE string support
% include &MacPath&BStrings.inc                             ;BSTR support
% include &COMPath&COM.inc                                  ;COM basic support
% include &COMPath&OAIDL.inc
% include &COMPath&COM_Dispatch.inc
% include &COMPath&COM_Interfaces.inc                       ;COM common interfaces
% include &COMPath&COM_Dispatch.inc                         ;Dispatch definitions and macros
% include &COMPath&COM_Dispatch.asm                         ;Dispatch procedures

include variant.inc

include WordHost.inc

.const                                                      ;Global GUIDs
DefGUID IID_NULL, %sGUID_NULL
;DefGUID IID_IUnknown, %sIID_IUnknown

.code
Start:
    ;***** ObjAsm32 initialization ***** 
    SysInit
    ;***** OLE / COM initialization *****
    invoke CoInitialize, 0
    OCall @WordHost::WordHost.Init, NULL
    OCall @WordHost::WordHost.DocOpen,    $OfsCBStr('C:\\1.doc')
    
    OCall @WordHost::WordHost.DocReplace, $OfsCBStr('One'),$OfsCBStr('Two')
    OCall @WordHost::WordHost.DocSaveAs,  $OfsCBStr('C:\\2.doc')
    OCall @WordHost::WordHost.DocClose
    @invoke MessageBox, 0, "Work done", "Notification", MB_OK
    OCall @WordHost::WordHost.Done
    ;***** OLE / COM cleanup *****
    invoke CoUninitialize
    ;***** ObjAsm32 cleanup *****
    SysDone
    invoke ExitProcess, 0
end Start